using System;
using Microsoft.Web.Services;
using System.Xml;
using System.Collections;

namespace ExchangeNetwork
{
	/// <summary>
	/// Summary description for NodeRequestorOutputFilter.
	/// </summary>
	public class NodeRequestorOutputFilter: SoapOutputFilter
	{
		public NodeRequestorOutputFilter()
		{
			
		}


		// Override the ProcessMessage method.
		public override void ProcessMessage(SoapEnvelope envelope)
		{

			SoapContext reqContext = envelope.Context;


			if (reqContext !=null) 
			{
        
				//now we need to extract href hash from the context 
				Hashtable table = (Hashtable) reqContext["hrefs"];

				if (table!=null)
				{


					XmlElement element = envelope.DocumentElement;

					XmlNodeList list = 
						element.GetElementsByTagName("NodeDocument", "http://www.ExchangeNetwork.net/schema/v1.0/node.xsd");

					foreach(XmlNode node in list)
					{

						XmlElement nameElement= node["name"];
						//now lets check in the table to get the href for that name
						String id = (String) table[nameElement.InnerText];
						//lets create the content tag
						XmlNode newNode = envelope.CreateNode(XmlNodeType.Element, "content", "http://xml.apache.org/xml-soap");
						XmlAttribute attrib = envelope.CreateAttribute("href");
						attrib.Value = id;
						newNode.Attributes.Append(attrib);
						node.AppendChild(newNode);
					}
				}
			}
		}	
	}
}
